<template>
    <v-container class="text-center">
        <v-simple-table fixed-header>
            <thead>
            <tr>
                <th class="headline text-capitalize text-center">{{ $t("Work.LNG_WORK_DATE") }}</th>
                <th class="headline text-capitalize text-center">{{ $t("Work.LNG_WORK_USER") }}</th>
                <th class="headline text-capitalize text-center">{{ $t("Work.LNG_WORK_FILE") }}</th>
                <th class="headline text-capitalize text-center">{{ $t("Work.LNG_WORK_DOWNLOAD") }}</th>
            </tr>
            </thead>
            <tbody>
            <tr v-for="work in works" :key="work.id + work.file_name">
                <td class="text-center">
                    <span v-if="work.file_name">{{ getDate(work.rendering_date) }}</span>
                </td>
                <td class="text-center">
                    {{ getUserInfos(work.user) }}
                </td>
                <td class="text-center">
                    {{ work.file_name }}
                </td>
                <td class="text-center">
                    <v-btn icon color="primary" large
                           :disabled="!work.file_name"
                           :loading="loading"
                           @click="downloadFile(work.id)">
                        <v-icon>mdi-download</v-icon>
                    </v-btn>
                </td>
            </tr>
            </tbody>
        </v-simple-table>
        <v-btn color="primary"
               :loading="loading"
               @click="downloadAllFile">
            <v-icon>mdi-download</v-icon>
            {{ $t("Work.LNG_WORK_DOWNLOAD_ALL") }}
        </v-btn>
    </v-container>
</template>

<script>
import Services from "@/services/api/index";
import { mapGetters } from "vuex";
import { SET_USER } from "@/store/mutations.type";
import dayjs from "dayjs";
import localizedFormat from "dayjs/plugin/localizedFormat";

export default {
    name: 'Work',
    data: () => ({
        works: [],
        taskId: -1,
        loading: false,
        interval: null
    }),
    computed: {
        ...mapGetters(['user']),
    },
    methods: {
        getUserInfos(user) {
            return user.first_name + " " + user.name + " (" + user.email + ")";
        },
        getDate(date) {
            let day = dayjs(date);
            return day.format("L LT");
        },
        async downloadFile(workId) {
            this.loading = true;
            let filename = null;
            Services.Work.downloadWork(this.taskId, workId)
                .then(res => {
                    filename = res.headers.get('content-disposition')?.replaceAll("\"", "").split(";")[1].split("filename=")[1].trim();
                    switch (res.status) {
                        case 200:
                            return res.blob();
                        case 401:
                            this.$router.push({ name: "Login" });
                            break;
                        default:
                            throw res.status + " " + res.statusText;
                    }
                })
                .then(blob => URL.createObjectURL(blob))
                .then(url => {
                    // window.open(url);
                    this.userDownloadFile(filename, url);
                    this.loading = false;
                })
                .catch(err => console.error(err));
        },
        async downloadAllFile() {
            this.loading = true;
            let filename = null;
            Services.Work.downloadAllWork(this.taskId)
                .then(res => {
                    filename = res.headers.get('content-disposition')?.replaceAll("\"", "").split(";")[1].split("filename=")[1].trim();
                    switch (res.status) {
                        case 200:
                            return res.blob();
                        case 401:
                            this.$router.push({ name: "Login" });
                            break;
                        default:
                            throw res.status + " " + res.statusText;
                    }
                })
                .then(blob => URL.createObjectURL(blob))
                .then(url => {
                    // window.open(url);
                    this.userDownloadFile(filename, url);
                    this.loading = false;
                })
                .catch(err => console.error(err));
        },
        userDownloadFile(filename, url) {
            let a = document.createElement("a");
            document.body.appendChild(a);
            a.style = "display: none";
            a.href = url;
            a.download = filename;
            a.click();
            window.URL.revokeObjectURL(url);
            a.remove();
        }
    },
    async mounted() {
        dayjs.extend(localizedFormat);
        dayjs.locale(this.$i18n.locale);
        if (!this.user) {
            this.$store.commit(SET_USER, await Services.getUser());
        }
        this.taskId = this.$route.params.taskId;
        this.works = await Services.Work.getWork(this.taskId);

        // setInterval(async () => {
        //     this.works = await Services.Work.getWork(this.taskId);
        // }, 5000)
    },
    destroyed() {
        // clearInterval(this.interval);
    }
}
</script>
